﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace WpfApp11
{
    class BackgroundProcessOne
    {

        static internal BackgroundWorker backgroundProcessOne;

        internal void Constructor()
        {
            backgroundProcessOne = new BackgroundWorker();

            backgroundProcessOne.DoWork -= (obj, e) => processWorker_DoWork(obj, e);
            backgroundProcessOne.DoWork += (obj, e) => processWorker_DoWork(obj, e);

            backgroundProcessOne.RunWorkerCompleted -= (obj, e) => processWorker_Completed(obj, e);
            backgroundProcessOne.RunWorkerCompleted += (obj, e) => processWorker_Completed(obj, e);
        }

        private void T__Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            if (!backgroundProcessOne.IsBusy)
            {
                backgroundProcessOne.RunWorkerAsync();
            }
        }

        private void processWorker_DoWork(Object sender, DoWorkEventArgs e)
        {
            // Process
            Thread.Sleep(2000);
        }


        private void processWorker_Completed(Object sender, RunWorkerCompletedEventArgs e)
        {
            OnUpdateProcessOneEvent();  
        }


        public delegate void ProcessOneEvent(Object source, EventArgs args);

        public event ProcessOneEvent UpdateProcessOneEvent;

        protected virtual void OnUpdateProcessOneEvent()
        {
            if (UpdateProcessOneEvent != null)
            {
                UpdateProcessOneEvent(this, EventArgs.Empty);
            }
        }
    }
}
