﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace WpfApp11
{
    class BackgroundProcessTwo
    {

        static internal BackgroundWorker backgroundProcessTwo;

        internal void Constructor()
        {
            backgroundProcessTwo = new BackgroundWorker();

            backgroundProcessTwo.DoWork -= (obj, e) => processWorker_DoWork(obj, e);
            backgroundProcessTwo.DoWork += (obj, e) => processWorker_DoWork(obj, e);

            backgroundProcessTwo.RunWorkerCompleted -= (obj, e) => processWorker_Completed(obj, e);
            backgroundProcessTwo.RunWorkerCompleted += (obj, e) => processWorker_Completed(obj, e);
        }

        private void T__Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            if (!backgroundProcessTwo.IsBusy)
            {
                backgroundProcessTwo.RunWorkerAsync();
            }
        }

        private void processWorker_DoWork(Object sender, DoWorkEventArgs e)
        {
            // Process
            Thread.Sleep(2000);
            MainWindow.new_maximum = RandomNumber(0,100);
        }

        private void processWorker_Completed(Object sender, RunWorkerCompletedEventArgs e)
        {
            OnUpdateProcessTwoEvent();
        }

        static int RandomNumber(int min, int max)
        {
            Random random = new Random(); return random.Next(min, max);
        }


        public delegate void ProcessTwoEvent(Object source, EventArgs args);

        public event ProcessTwoEvent UpdateProcessTwoEvent;

        protected virtual void OnUpdateProcessTwoEvent()
        {
            if (UpdateProcessTwoEvent != null)
            {
                UpdateProcessTwoEvent(this, EventArgs.Empty);
            }
        }
    }
}
