﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp11
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        internal BackgroundProcessOne processOne = new BackgroundProcessOne();
        internal BackgroundProcessTwo processTwo = new BackgroundProcessTwo();


        static internal Int32 new_maximum { set; get; }

        public MainWindow()
        {

            processOne.UpdateProcessOneEvent -= BackgroundProcessOne_UpdateProcessOneEvent;
            processOne.UpdateProcessOneEvent += BackgroundProcessOne_UpdateProcessOneEvent;

            processTwo.UpdateProcessTwoEvent -= BackgroundProcessTwo_UpdateProcessOneEvent;
            processTwo.UpdateProcessTwoEvent += BackgroundProcessTwo_UpdateProcessOneEvent;

            new_maximum = 10;

            InitializeComponent();
        }

        private void Manual_Click(object sender, RoutedEventArgs e)
        {
            // Manual test of slider change
            new_maximum = RandomNumber(0, 100);
            updateSlider();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            // Click button to start process one (trigger a chain of processes)
            processOne.Constructor();
        }

        private void BackgroundProcessOne_UpdateProcessOneEvent(object source, EventArgs args)
        {
            // On completion of process one start process two
            processTwo.Constructor();
        }

        private void BackgroundProcessTwo_UpdateProcessOneEvent(object source, EventArgs args)
        {
            // On completion of process two update the slider
            updateSlider();
        }

        static int RandomNumber(int min, int max)
        {
            Random random = new Random(); return random.Next(min, max);
        }



        private void updateSlider()
        {
            if (MySlider.Maximum != new_maximum)
            {
                MySlider.Maximum = new_maximum;
                MySlider.Value = new_maximum / 2;
            }

        }
    }


}
